package net.java.amateras.uml.model;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.draw2d.geometry.Rectangle;

public abstract class AbstractUMLEntityModel extends AbstractUMLModel {
	
	private Rectangle constraint;
	// ̃fLтĂRlNṼXg
	private List sourceConnections = new ArrayList();
	// ̃fɌĒĂRlNṼXg
	private List targetConnections = new ArrayList();
	
	private List children = new ArrayList();
	
	public static final String P_CONSTRAINT = "_constraint";
	public static final String P_SOURCE_CONNECTION = "_source_connection";
	public static final String P_TARGET_CONNECTION = "_target_connection";
	public static final String P_CHILDREN = "_children";
	
	public Rectangle getConstraint() {
		return constraint;
	}
	
	public void addOperation(OperationModel model){
		this.children.add(model);
		firePropertyChange(P_CHILDREN,null,model);
	}
	
	public void addAttribute(AttributeModel model){
		this.children.add(model);
		firePropertyChange(P_CHILDREN,null,model);
	}
	
	public void removeOperation(OperationModel model){
		this.children.remove(model);
		firePropertyChange(P_CHILDREN,null,model);
	}
	
	public void removeAttribute(AttributeModel model){
		this.children.remove(model);
		firePropertyChange(P_CHILDREN,null,model);
	}
	
	public List getChildren(){
		return this.children;
	}
	
	public void setConstraint(Rectangle constraint) {
		this.constraint = constraint;
		firePropertyChange(P_CONSTRAINT, null, constraint);
	}
	
	/** ̃foRlNV f̒ǉ */
	public void addSourceConnection(Object connx) {
		sourceConnections.add(connx);
		firePropertyChange(P_SOURCE_CONNECTION, null, connx);
	}
	
	/** ̃fɐڑRlNV f̒ǉ */
	public void addTargetConnection(Object connx) {
		targetConnections.add(connx);
		firePropertyChange(P_TARGET_CONNECTION, null, connx);
	}
	
	/** ̃fڑƂRlNṼXgԂ */
	public List getModelSourceConnections() {
		return sourceConnections;
	}
	
	/** ̃fڑƂRlNṼXgԂ */
	public List getModelTargetConnections() {
		return targetConnections;
	}
	
	/** ̃fRlNṼ\[X؂藣 */
	public void removeSourceConnection(Object connx) {
		sourceConnections.remove(connx);
		firePropertyChange(P_SOURCE_CONNECTION, connx, null);
	}
	
	/** ̃fRlNṼ^[Qbg؂藣 */
	public void removeTargetConnection(Object connx) {
		targetConnections.remove(connx);
		firePropertyChange(P_TARGET_CONNECTION, connx, null);
	}
}
